/***************** (c) 2007 BTC Korporacja ***********************************
                     http://www kamami.com
PROJECT  : LEDs
BOARD    : ZL25ARM + ZL24ARM (STR912X44)
COMPILER : GCC 4.1.1

******************************************************************************

    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT 
    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING 
    FROM USE OF THIS SOFTWARE.

******************************************************************************

DESCRIPTION :
    Simple LEDs demonstration.
    Jumpers settings on ZL25ARM:
	    JP1: 1-2 (ON)
        
******************************************************************************/

// STR9x IO register & structures
#include "91x_map.h"

// System Control Unit definitions
#include "91x_scu.h"

// waits "howmuch" cycles
void delay(int howmuch) 
{ 
    while(howmuch--) 
	asm volatile ("nop"); 
}

int main()
{
// because GPIO ports are initially in RESET state
// we need to disable their reset signals first

// disable reset signal for GPIO port 5
    SCU->PRR1 |= __GPIO7;

// enable peripheral clock for GPIO port 5
    SCU->PCGR1 |= __GPIO7;

// set output type to push-pull for all port 5 lines
    SCU->GPIOTYPE[7] = 0x0000 ;

// set all port 7 lines to output (both registers below need to be set for GPIO to work)
    SCU->GPIOOUT[7]  = 0x5555;
    GPIO7->DDR = 0xff;

// infinite loop
    for(;;)
    {
        int i;

        for(i=0;i<8;i++)
        {
            // turn LEDs on/off
            GPIO7->DR[0x3fc]=(1<<i);

            // wait a while
            delay(100000);
        }
    }

    return 0;
}
