/***************** (c) 2007 BTC Korporacja ***********************************
                     http://www kamami.com
PROJECT  : Switches - reading port state
BOARD    : ZL25ARM + ZL24ARM (STR912X44)
COMPILER : GCC 4.1.1

******************************************************************************

    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT 
    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING 
    FROM USE OF THIS SOFTWARE.

******************************************************************************

DESCRIPTION :
    Pressing any button is shown on LCD.
    Jumpers settings on ZL25ARM:
	    not required
        
******************************************************************************/

// STR9x IO register & structures
#include "91x_map.h"

// System Control Unit definitions
#include "91x_scu.h"

#include "lcd.h"

// waits "howmuch" cycles
void delay(int howmuch)
{
    while(howmuch--)
        asm volatile ("nop");
}

void initialize()
{
// because GPIO ports are initially in RESET state
// we need to disable their reset signals first

// disable reset signal for GPIO port 3
    SCU->PRR1 |= __GPIO3;

// enable peripheral clock for GPIO port 3
    SCU->PCGR1 |= __GPIO3;

// set all port 3 lines to input (both registers below need to be set for GPIO to work)
    SCU->GPIOOUT[4] = 0;;
    GPIO4->DDR = 0;
}

int main()
{

// initialize GPIO
    initialize();

// initialize LCD display
    LCD_init();
    LCD_control(ON, BLINK, SHOW);
    LCD_clear();
    LCD_setpos(0);
    LCD_putstring("Switch state: ");

    for(;;)
    {
        unsigned char val = GPIO3->DR[0x3fc];

        LCD_setpos(64);
        if(val & (1<<4)) LCD_putstring("    "); else LCD_putstring("SW0 ");
        if(val & (1<<5)) LCD_putstring("    "); else LCD_putstring("SW1 ");
        if(val & (1<<6)) LCD_putstring("    "); else LCD_putstring("SW2 ");
        if(val & (1<<7)) LCD_putstring("    "); else LCD_putstring("SW3 ");

        delay(50000);
    }


    return 0;
}
